// Generated by CoffeeScript 1.7.1
(function() {
  var SocketIORemoteServiceClient;

  SocketIORemoteServiceClient = (function() {
    function SocketIORemoteServiceClient() {}

    SocketIORemoteServiceClient.prototype.initialize = function(options, callback) {
      if (options == null) {
        options = {};
      }
      if (callback == null) {
        callback = function() {};
      }
      this._callbacks = {};
      if (options.ioClientInstance) {
        this._io_socket = options.ioClientInstance;
        return this._initializeRPCResponseListener(callback);
      } else {
        this._io_socket = require('socket.io-client')('http://localhost:3000');
        return this._io_socket.on('connect', (function(_this) {
          return function() {
            return _this._initializeRPCResponseListener(callback);
          };
        })(this));
      }
    };

    SocketIORemoteServiceClient.prototype._initializeRPCResponseListener = function(callback) {
      this._io_socket.on('RPC_Response', (function(_this) {
        return function(response) {
          return setTimeout(function() {
            return _this._handleRpcResponse(response);
          }, 0);
        };
      })(this));
      return callback();
    };

    SocketIORemoteServiceClient.prototype._handleRPCResponse = function(response) {
      if (!response.rpcId) {
        throw new Error('Missing rpcId in RPC Response');
      }
      if (!(response.rpcId in this._callbacks)) {
        throw new Error("No callback registered for id " + response.rpcId);
      }
      this._callbacks[response.rpcId](response.err, response.data);
      return delete this._callbacks[response.rpcId];
    };

    SocketIORemoteServiceClient.prototype.rpc = function(payload, callback) {
      var rpcId;
      if (callback == null) {
        callback = function() {};
      }
      rpcId = this._generateUid();
      payload.rpcId = rpcId;
      this._callbacks[rpcId] = callback;
      return this._io_socket.emit('RPC_Request', payload);
    };

    SocketIORemoteServiceClient.prototype._handleRpcResponse = function(response) {
      if (!response.rpcId) {
        throw new Error('Missing rpcId in RPC Response');
      }
      if (!(response.rpcId in this._callbacks)) {
        throw new Error("No callback registered for id " + response.rpcId);
      }
      this._callbacks[response.rpcId](response.err, response.data);
      return delete this._callbacks[response.rpcId];
    };

    SocketIORemoteServiceClient.prototype._generateUid = function(separator) {
      var S4, delim;
      S4 = function() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
      };
      delim = separator || "-";
      return S4() + S4() + delim + S4() + delim + S4() + delim + S4() + delim + S4() + S4() + S4();
    };

    SocketIORemoteServiceClient.prototype.subscribe = function(channel, eventName, handlerFn) {
      this._io_socket.join(channel);
      return this._io_socket.on(eventName, handlerFn);
    };

    return SocketIORemoteServiceClient;

  })();

  module.exports = new SocketIORemoteServiceClient;

}).call(this);
